---
title: 'RangeError: invalid array length'
slug: Web/JavaScript/Reference/Errors/Invalid_array_length
tags:
  - Error
  - Errors
  - JavaScript
  - RangeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "Invalid array length" occurs when creating an {{jsxref("Array")}} or an {{jsxref("ArrayBuffer")}} which has a length which is either negative or larger or equal to 2<sup>32</sup>, or when setting the {{jsxref("Array.length")}} property to a value which is either negative or larger or equal to 2<sup>32</sup>.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">RangeError: Array length must be a finite positive integer (Edge)
RangeError: invalid array length (Firefox)
RangeError: Invalid array length (Chrome)
RangeError: Invalid array buffer length (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("RangeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>An invalid array length might appear in these situations:</p>

<ul>
 <li>When creating an {{jsxref("Array")}} or an {{jsxref("ArrayBuffer")}} which has a length which is either negative or larger or equal to 2<sup>32</sup>, or</li>
 <li>when setting the {{jsxref("Array.length")}} property to a value which is either negative or larger or equal to 2<sup>32</sup>.</li>
</ul>

<p>Why are <code>Array</code> and <code>ArrayBuffer</code> length limited? The <code>length</code> property of an <code>Array</code> or an <code>ArrayBuffer</code> is represented with an unsigned 32-bit integer, that can only store values which are in the range from 0 to 2<sup>32</sup>-1.</p>

<p>If you are creating an <code>Array</code>, using the constructor, you probably want to use the literal notation instead, as the first argument is interpreted as the length of the <code>Array</code>.</p>

<p>Otherwise, you might want to clamp the length before setting the length property, or using it as argument of the constructor.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_cases">Invalid cases</h3>

<pre class="brush: js example-bad">new Array(Math.pow(2, 40))
new Array(-1)
new ArrayBuffer(Math.pow(2, 32))
new ArrayBuffer(-1)

let a = [];
a.length = a.length - 1;         // set -1 to the length property

let b = new Array(Math.pow(2, 32) - 1);
b.length = b.length + 1;         // set 2^32 to the length property
</pre>

<h3 id="Valid_cases">Valid cases</h3>

<pre class="brush: js example-good">[ Math.pow(2, 40) ]                     // [ 1099511627776 ]
[ -1 ]                                  // [ -1 ]
new ArrayBuffer(Math.pow(2, 32) - 1)
new ArrayBuffer(0)

let a = [];
a.length = Math.max(0, a.length - 1);

let b = new Array(Math.pow(2, 32) - 1);
b.length = Math.min(0xffffffff, b.length + 1);

// 0xffffffff is the hexadecimal notation for 2^32 - 1
// which can also be written as (-1 &gt;&gt;&gt; 0)
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array")}}</li>
 <li>{{jsxref("Array.length")}}</li>
 <li>{{jsxref("ArrayBuffer")}}</li>
</ul>
